<?php

namespace Ems\Repository;

use Ems\Util\Utils;

class ProcessoRepository {

    public function getStatusProcesso(
        int $nrOrg,
        int $nrOrgPadrao
    ): array {
        $sql = <<<SQL
            SELECT
              CDSTATUS,
              DSSTATUS
              FROM DES_STATUS
             WHERE (NRORG = :P_NRORG_PADRAO OR NRORG = :P_NRORG)
             ORDER BY DSSTATUS
SQL;

        $params = [
            'P_NRORG'           => $nrOrg,
            'P_NRORG_PADRAO'    => $nrOrgPadrao,
        ];

        $std = Utils::getEntityManager()->getConnection()->prepare($sql);
        $std->execute($params);

        $result = $std->fetchAll();

        return $result;
    }
}