CREATE OR REPLACE TRIGGER USR_ATU_ITEMPRODUTO_NGD
BEFORE DELETE OR INSERT OR UPDATE OF QTITEMPROD,
                                     VRUNITITEM
ON ITEMPRODUTO  FOR EACH ROW
DECLARE
  V_CHAVE       VARCHAR2(300);
  V_CDARVPROD   PRODUTO.CDARVPROD%TYPE;
  V_CDFILIEMIT  NOTAFISCAL.CDFILIEMIT%TYPE;
  V_CDFILIRECE  NOTAFISCAL.CDFILIRECE%TYPE;
  V_DTENTRSAID  USR_ITEMPRODUTO_NGD.DTENTRSAID%TYPE;
BEGIN
   IF DELETING THEN
      SELECT MAX(CDARVPROD)
        INTO V_CDARVPROD
        FROM PRODUTO
       WHERE CDPRODUTO = :NEW.CDPRODUTO;
      SELECT MAX(CDFILIEMIT), MAX(CDFILIRECE), MAX(TO_CHAR(DTENTRSAID, 'YYYYMMDD'))
        INTO V_CDFILIEMIT, V_CDFILIRECE, V_DTENTRSAID
        FROM NOTAFISCAL
       WHERE NOTAFISCAL.CDFILIAL   = :NEW.CDFILIAL
         AND NOTAFISCAL.NRLANCTONF = :NEW.NRLANCTONF;

      SELECT NVL(MAX(CDFILIEMIT), '')
        INTO V_CHAVE
        FROM USR_ITEMPRODUTO_NGD
       WHERE USR_ITEMPRODUTO_NGD.CDFILIAL     <> :NEW.CDFILIAL
         AND USR_ITEMPRODUTO_NGD.NRLANCTONF   <> :NEW.NRLANCTONF
         AND USR_ITEMPRODUTO_NGD.CDARVPROD    =  V_CDARVPROD
         AND USR_ITEMPRODUTO_NGD.CDFILIEMIT   =  V_CDFILIEMIT
         AND USR_ITEMPRODUTO_NGD.CDFILIRECE   =  V_CDFILIRECE
         AND USR_ITEMPRODUTO_NGD.DTENTRSAID   = V_DTENTRSAID;

      IF V_CHAVE = '' THEN
         UPDATE USR_ITEMPRODUTO_NGD
            SET TPINTERFACE        = 'E',
                DTINTERFACEORI     = SYSDATE,
                DTINTERFACEDEST    = NULL,
                STATUS             = '1'
          WHERE USR_ITEMPRODUTO_NGD.CDFILIAL   = :NEW.CDFILIAL
            AND USR_ITEMPRODUTO_NGD.NRLANCTONF = :NEW.NRLANCTONF
            AND USR_ITEMPRODUTO_NGD.CDARVPROD  = V_CDARVPROD;
         INSERT
           INTO USR_LOG_NGD(IDPROCESSO, DTLOG, STATUS, OBSSTATUS, IDPESQITEM)
         VALUES ('USR_ITEMPRODUTO_NGD', SYSDATE, '0', NULL, :NEW.CDFILIAL||'-'||:NEW.NRLANCTONF||'-'||V_CDARVPROD);
      ELSE
         UPDATE ITEMPRODUTO
            SET USR_NGD_INTEGRADO = 'N'
          WHERE ITEMPRODUTO.CDFILIAL        <> :NEW.CDFILIAL
            AND ITEMPRODUTO.NRLANCTONF      <> :NEW.NRLANCTONF
            AND NVL(USR_NGD_INTEGRADO, 'N') =  'S'
            AND EXISTS(SELECT 1
                         FROM NOTAFISCAL
                        WHERE NOTAFISCAL.CDFILIAL   =  ITEMPRODUTO.CDFILIAL
                          AND NOTAFISCAL.NRLANCTONF =  ITEMPRODUTO.NRLANCTONF
                          AND NOTAFISCAL.IDENTRSAIDOP = 'S'
                          AND NOTAFISCAL.IDSTATUSNFE  = 'A'
                          AND NOTAFISCAL.CDFILIAL   <> :NEW.CDFILIAL
                          AND NOTAFISCAL.NRLANCTONF <> :NEW.NRLANCTONF
                          AND NOTAFISCAL.CDFILIEMIT =  V_CDFILIEMIT
                          AND NOTAFISCAL.CDFILIRECE =  V_CDFILIRECE
                          AND NOTAFISCAL.DTENTRSAID =  V_DTENTRSAID);
      END IF;
   ELSE
     :NEW.USR_NGD_INTEGRADO := 'N';
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_ATU_ITEMPRODUTO_NGD','6.39.030'); END;
/
